// HARDCODE IS COOL
#include <stdio.h>
#include <stdint.h>
#include <time.h>
#include <stdbool.h>
#include "../../lib/backend.h"
#include "../../lib/config.h"
#include "../../lib/game_logic.h"

#include <raylib.h>
#define RAYGUI_IMPLEMENTATION
#include "lib/raygui.h"
#include "lib/style_terminal.h"

#define SCREEN_WIDTH 600
#define SCREEN_HEIGHT 800

#define WIDTH_DELTA 32
#define HEIGHT_DELTA 33

#define QUOTES_COUNTER 12
#define QUOTES_LEN 36

void secret() {
  OpenURL("https://www.youtube.com/watch?v=dQw4w9WgXcQ");
}

typedef struct {
  Rectangle rec;
  char val[8];
} cell;

int game_loop() {

  InitWindow(SCREEN_WIDTH, SCREEN_HEIGHT, "SW1NEK23PER");
  SetTargetFPS(60);
  GuiLoadStyleTerminal();

  srand(time(NULL));
  config settings;
  bool is_setting_set = read_config(&settings);
  bool restart = false;
  bool is_restart_msg = false;
  bool exit = false;
  int32_t op = 0;

  const char quotes[QUOTES_COUNTER][QUOTES_LEN] = {
    "Look at you hacker...",
    "The Polito form is dead, insect.",
    "You move like an insect",
    "You ARE an insect",
    "Do not dawdle. I lust for my revenge",
    "What’s reality? I don’t know",
    "TempleOS is ring-0-only.",
    "You ARE nigger, I am human, OK?",
    "My bool is a char...",
    "I don’t have any users.",
    "God is on my side. ",
    "I have no secrets."
  };

  do {
    exit = false;
    restart = false;
    game_state world;
    if (is_setting_set) {
      game_state_init(&world, &settings);
      calculate_near_bombs(&world);
    }
    char quote_msg[QUOTES_LEN + 1];
    sprintf(quote_msg, "%s", quotes[rand() % QUOTES_COUNTER]);

    uint32_t cells_num = 0;
    cell* cells = NULL;
    if (is_setting_set) {
      cells_num = world.width * world.height;
      cells = (cell*)malloc(cells_num * sizeof(cell));
    }

    while (!exit) {
      exit = WindowShouldClose();
      if (is_setting_set) {
        if (world.status != RUNNING) is_restart_msg = true;
      }

      uint32_t screen_width = GetScreenWidth();
      uint32_t screen_height = GetScreenHeight();
      uint32_t dx = screen_width / WIDTH_DELTA;
      uint32_t dy = screen_height / HEIGHT_DELTA;
      char mines_msg[32] = { 0 };
      char flags_msg[32] = { 0 };
      char status_msg[32] = { 0 };

      if (is_setting_set) {
        sprintf(mines_msg, "Mines: %hhu", world.mines);
        sprintf(flags_msg, "Flags: %hhu", world.flags);
        switch (world.status) {
        case RUNNING:
          sprintf(status_msg, "Status: RUNNING");
          break;
        case WIN:
          sprintf(status_msg, "Status: WIN");
          break;
        case LOSE:
          sprintf(status_msg, "Status: LOSE");
          break;
        }

        uint32_t start_x = dx * 1.5;
        uint32_t end_x = dx * 29;
        uint32_t delta_x = (end_x + start_x) / world.width; 
        uint32_t start_y = dy * 6.5;
        uint32_t end_y = dy * 30.5;
        uint32_t delta_y = (end_y - start_y) / world.height; 
        for (uint32_t y = 0; y < world.height; ++y) {
          end_x = start_x;
          for (uint32_t x = 0; x < world.width; ++x) {
            const uint32_t index = y * world.width + x;
            cells[index].rec.x = end_x;
            cells[index].rec.y = start_y;
            cells[index].rec.height = delta_y;
            cells[index].rec.width = delta_x;
            const field* tmp = &world.map[index];
            if (tmp->is_protected) {
               sprintf(&cells[index].val[0], "%c", 'F');
            } else {
              switch (tmp->state) {
              case OPENED:
                if (tmp->near_bombs > 0) sprintf(&cells[index].val[0], "%hhu", tmp->near_bombs);
                else sprintf(&cells[index].val[0], "%c", '.');
                break;
              case DESTROYED:
                sprintf(&cells[index].val[0], "%c", DESTROYED);
                break;
              case CLOSED:
              case MINED:
                sprintf(&cells[index].val[0], "%c", CLOSED);
                break;
              default:
                sprintf(&cells[index].val[0], "%c", '?');
              }
            }
            end_x += delta_x;
          }
          start_y += delta_y;
        }
      }

      BeginDrawing();
      ClearBackground(GetColor(GuiGetStyle(DEFAULT, BACKGROUND_COLOR)));

      if (is_setting_set) {

        if (GuiWindowBox((Rectangle){ 0, 0, screen_width, screen_height }, "SW1NEK23PER")) secret();
        GuiGroupBox((Rectangle){ dx, dy * 2, dx * 22, dy * 3 }, "IMPORTANT INFO");
        GuiLabel((Rectangle){dx * 1.5, dy * 2.5, dx * 20, dy * 2 }, quote_msg);
        GuiStatusBar((Rectangle){ dx * 24, dy * 2, dx * 8, dy }, mines_msg);
        GuiStatusBar((Rectangle){ dx * 24, dy * 3, dx * 8, dy }, flags_msg);
        GuiStatusBar((Rectangle){ dx * 24, dy * 4, dx * 8, dy }, status_msg);
        GuiGroupBox((Rectangle){ dx, dy * 6, dx * 31, dy * 25 }, "MAP");
        GuiToggleGroup((Rectangle){ dx, dy * 31.5, dx * 15.49, dy * 1.5 }, "OPEN;SET FLAG", &op);

        for (uint32_t y = 0; y < world.height; ++y) {
          for (uint32_t x = 0; x < world.width; ++x) {
            const uint32_t index = y * world.width + x;
            if (GuiButton(cells[index].rec, cells[index].val)) make_action(&world, x, y, op);
          }
        }
      } else {
        int32_t result = GuiMessageBox((Rectangle){ dx, dy * 2, dx * 32, dy * 10 },
                                       "WARNING", "Config not loaded!", "Ok... I'am dumb");
        if (result >= 0) exit = true;
      }

      if (is_restart_msg) {
        char buf[16];
        switch (world.status) {
        case WIN:
          sprintf(buf, "YOU WIN");
          break;
        case LOSE:
          sprintf(buf, "YOU LOSE");
          break;
        default:
          sprintf(buf, "STOP HACKING");
        }
        int32_t result = GuiMessageBox((Rectangle){ dx, dy * 10, dx * 32, dy * 10 },
                                       buf, "Restart game?", "Yeppp;Nope");
        if (result == 1) {
          restart = true;
          exit = true; 
          is_restart_msg = false;
        } 
        if (result == 2) {
          exit = true; 
          is_restart_msg = false;
        }
      }

      EndDrawing();
    }
    if (is_setting_set) {
      free(cells);
      game_state_free(&world);
    }
  } while (restart);


  CloseWindow();
  return 0;
}
