#ifndef CONFIG_H
#define CONFIG_H

#include <stdint.h>
#include <stdbool.h>

#define WIDTH_LIMIT 20
#define HEIGHT_LIMIT 20
#define MINES_LIMIT 20
#define FLAGS_LIMIT 20
#define DEFAULT_CONFIG_FILENAME "settings.ini"

typedef struct {
  uint8_t width;
  uint8_t height;
  uint8_t mines;
  uint8_t flags;
} config;

typedef enum { WIDTH, HEIGHT, MINES, FLAGS, UNKNOWN } options;

bool read_config(config *conf);

#endif
